function y=OPTAcurves(N)

M=[1 2 4 8 16 1000];
EsN0=linspace(-5,20,N);
EsN0l=10.^(EsN0/10);
SNR=zeros(length(M),N);
for i=1:length(M)
    SNR(i,:)=(1+2*EsN0l/M(i)).^M(i);
end
SNR=10*log10(SNR);

plot(EsN0,[SNR(1,:)',SNR(2,:)',SNR(3,:)',SNR(4,:)',SNR(5,:)']);
hold on;
plot(EsN0,SNR(6,:)','--')
hold off;
grid on;axis([-5 20 0 100]);
xlabel('E_s/N_0 (dB)'),ylabel('SNR(dB)');
y=1;