function testfad(M);

fa=linspace(1,2,M);
fa=ones(1,M);
x=2;
SigmaX=1;SigmaN=1;Esl=10;betaa=1;
noise=randn(M+1,1)*1;

A=zeros(1,M+1);B=zeros(1,M+1);D=zeros(1,M+1);
A(1)=0;B(1)=0;D(1)=SigmaX;

for i=2:(M+1)
    A(i)=sqrt((2*Esl/M)/D(i-1));
    B(i)=sqrt(D(i-1)*(2*Esl/M))/((2*Esl/M)+SigmaN);
    D(i)=D(i-1)*SigmaN/((2*Esl/M)+SigmaN);
end

u=0;
d=0;y=0;
for i=2:M+1
    u=u+1;
    a(i)=(x-d(i-1))*betaa*A(i);
    c(i)=(a(i)*fa(u)+noise(i))*B(i);
    y(i)=c(i)+y(i-1);
    d(i)=y(i)*fa(u)*betaa;
end

figure();
subplot(3,3,1)
plot(A(2:end))
title('A')

subplot(3,3,2)
t=1:M;
plot(t,B(2:end),t,D(2:end))
title('B & D')

subplot(3,3,3)
plot(fa)
title('fading')

subplot(3,3,4)
plot(a)
title('a')

subplot(3,3,5)
plot(c)
title('c')

subplot(3,3,6),hold on;
plot(y)
plot((1:M+1),x,'--')
title('y'),hold off;

subplot(3,3,7)
plot(d)
title('d')