function y=OPTAcurves2(N)

%Draw OPTA

EsN0=[1 2 3 4 5 6];
M=linspace(0.1,16,N);
EsN0l=10.^(EsN0/10);
SNR=zeros(length(EsN0),N);
for i=1:length(EsN0)
    SNR(i,:)=(1+2*EsN0l(i)./M).^M;
end
SNR=10*log10(SNR);

plot(M,[SNR(1,:)',SNR(2,:)',SNR(3,:)',SNR(4,:)',SNR(5,:)',SNR(6,:)']);
grid on;axis([1 16 4 30]);
xlabel('Signal expansion factor J=B_c/B_s'),ylabel('SNR(dB)');
y=1;

% figure(2);
% EsN0=[10 20 30 40 50 60];
% M=linspace(0.1,16,N);
% EsN0l=10.^(EsN0/10);
% SNR=zeros(length(EsN0),N);
% for i=1:length(EsN0)
%     SNR(i,:)=(1+2*EsN0l(i)./M).^M;
% end
% SNR=10*log10(SNR);
% 
% plot(M,[SNR(1,:)',SNR(2,:)',SNR(3,:)',SNR(4,:)',SNR(5,:)',SNR(6,:)']);
% grid on;%axis([1 16 0 30]);
% xlabel('Signal expansion factor J=B_c/B_s'),ylabel('SNR(dB)');
% y=1;