function drawsystemcomparations(N,SigmX,SigmN);

% This function will draw the SNR and the delay and power for OPTA, system
% 1 and system2.


% EsN0=linspace(0,40,50);
% 
% maxbeta=6;
% 
% SigmaX=10^(SigmX/10);
% SigmaN=10^(SigmN/10);
% x=randn(1,N)*SigmaX;
% noise=randn(16+1,length(x))*SigmaN;
% M=[2,8];   
% 
% SNRsys1=zeros(length(M),length(EsN0));
% maxbuffsys1=zeros(length(M),length(EsN0));
% powersys1=zeros(length(M),length(EsN0));
% 
% SNRsys2=zeros(2,length(EsN0));
% maxbuffsys2=zeros(2,length(EsN0));
% powersys2=zeros(2,length(EsN0));
% 
% %--------------------OPTA with ideal feddback-----------------------
% Mo=[16,8,4,2];
% EsN0l=10.^(EsN0/10);
% SNRo=zeros(length(Mo),length(EsN0));
% for i=1:length(Mo)
%     SNRo(i,:)=(1+2*EsN0l/Mo(i)).^Mo(i);
% end
% SNRo=10*log10(SNRo);
% %------------------------------------------------------------------
% 
% %Rician fading with low variance-----------------------------------
% [fading, tc]=genfading('rice',5,1/44100,N*10*max(M),0.01,100);
% fading=fading/mean(fading);fading=fading/2+(1-1/2);
% %   System1--------------------------------------------------------
% tc=[16*4*2,16*2];
% for j=1:length(M)
%     for i=1:length(EsN0)
%         [out,SNRsys1(j,i),buffhist,smallfading,powersys1(j,i)]=systembufferframe(x,EsN0(i),M(j),SigmX,SigmN,noise,tc(j),fading,maxbeta);
%         maxbuffsys1(j,i)=max(buffhist);
%     end
% end
% 
% %   System2--------------------------------------------------------
% tc=8*2;
% for i=1:length(EsN0)
%     [out,SNRsys2(1,i),buffhist,smallfading,powersys2(1,i)]=systembufferMM(x,EsN0(i),SigmX,SigmN,noise,tc,fading,maxbeta);
%     maxbuffsys2(1,i)=max(buffhist);
% end
% for i=1:length(EsN0)
%     [out,SNRsys2(2,i),buffhist,smallfading,powersys2(2,i)]=systembufferM(x,EsN0(i),SigmX,SigmN,noise,tc,fading,maxbeta);
%     maxbuffsys2(2,i)=max(buffhist);
% end
% 
% %PLOT
% figure();
% subplot(2,2,1);
% plot(10*log10(fading));
% axis([0 1e6 -20 5]); %For rician fading
% xlabel('samples'),ylabel('dB')
% hold off;
% 
% subplot(2,2,2);hold on;
% plot(EsN0,SNRo(1,:),'k-');plot(EsN0,SNRo(2,:),'k--');plot(EsN0,SNRo(3,:),'k-.');plot(EsN0,SNRo(4,:),'k:');
% plot(EsN0,SNRsys1(1,:));plot(EsN0,SNRsys1(2,:),'r');
% plot(EsN0,SNRsys2(1,:),'g');plot(EsN0,SNRsys2(2,:),'m');
% 
% grid on;axis([0 40 0 80]);
% xlabel('E_s/N_0 (dB)'),ylabel('SNR(dB)');
% legend('OPTA-M=16','OPTA-M=8','OPTA-M=4','OPTA-M=2','Sys1-M=2','Sys-M=8','Sys2-R_i_n=8','Sys2-R_i_n=2','Location','SouthEastOutside');
% hold off;
% 
% %Rayleigh fading---------------------------------------------------
% [fading, tc]=genfading('rayleigh',5,1/44100,N*16*5,0.01);
% %   System1--------------------------------------------------------
% tc=[2*4*2,2*2];
% for j=1:length(M)
%     for i=1:length(EsN0)
%         [out,SNRsys1(j,i),buffhist,smallfading,powersys1(j,i)]=systembufferframe(x,EsN0(i),M(j),SigmX,SigmN,noise,tc(j),fading,maxbeta);
%         maxbuffsys1(j,i)=max(buffhist);
%     end
% end
% 
% %   System2--------------------------------------------------------
% tc=1*2;
% for i=1:length(EsN0)
%     [out,SNRsys2(1,i),buffhist,smallfading,powersys2(1,i)]=systembufferMM(x,EsN0(i),SigmX,SigmN,noise,tc,fading,maxbeta);
%     maxbuffsys2(1,i)=max(buffhist);
% end
% for i=1:length(EsN0)
%     [out,SNRsys2(2,i),buffhist,smallfading,powersys2(2,i)]=systembufferM(x,EsN0(i),SigmX,SigmN,noise,tc,fading,maxbeta);
%     maxbuffsys2(2,i)=max(buffhist);
% end
% 
% %PLOT
% subplot(2,2,3);
% plot(10*log10(fading));
% axis([0 1e6 -20 5]); %For rician fading
% xlabel('samples'),ylabel('dB')
% hold off;
% 
% subplot(2,2,4);hold on;
% plot(EsN0,SNRo(1,:),'k-');plot(EsN0,SNRo(2,:),'k--');plot(EsN0,SNRo(3,:),'k-.');plot(EsN0,SNRo(4,:),'k:');
% plot(EsN0,SNRsys1(1,:));plot(EsN0,SNRsys1(2,:),'r');
% plot(EsN0,SNRsys2(1,:),'g');plot(EsN0,SNRsys2(2,:),'m');
% 
% grid on;axis([0 40 0 80]);
% xlabel('E_s/N_0 (dB)'),ylabel('SNR(dB)');
% legend('OPTA-M=16','OPTA-M=8','OPTA-M=4','OPTA-M=2','Sys1-M=2','Sys-M=8','Sys2-R_i_n=8','Sys2-R_i_n=2','Location','SouthEastOutside');
% hold off;

%**************************************************************************
%*                          DELAY & POWER                                 *
%**************************************************************************
EsN0=10;

maxbeta=linspace(0.5,18,50);

SigmaX=10^(SigmX/10);
SigmaN=10^(SigmN/10);
x=randn(1,N)*SigmaX;
noise=randn(16+1,length(x))*SigmaN;
M=[2,8];   

SNRsys1=zeros(length(M),length(maxbeta));
maxbuffsys1=zeros(length(M),length(maxbeta));
powersys1=zeros(length(M),length(maxbeta));

SNRsys2=zeros(length(M),length(maxbeta));
maxbuffsys2=zeros(length(M),length(maxbeta));
powersys2=zeros(length(M),length(maxbeta));

%Rayleigh fading---------------------------------------------------
[fading, tc]=genfading('rayleigh',5,1/44100,N*16*6,0.01);

%   System1---------------------------------------------------------
tc=[2*4*2,2*2];
for j=1:length(M)
    for i=1:length(maxbeta)
        [out,SNRsys1(j,i),buffhist,smallfading,powersys1(j,i)]=systembufferframe(x,EsN0,M(j),SigmX,SigmN,noise,tc(j),fading,maxbeta(i));
        maxbuffsys1(j,i)=max(buffhist);
    end    
end

%   System2--------------------------------------------------------
tc=1*2;
for i=1:length(maxbeta)
    [out,SNRsys2(1,i),buffhist,smallfading,powersys2(1,i)]=systembufferMM(x,EsN0,SigmX,SigmN,noise,tc,fading,maxbeta(i));
    maxbuffsys2(1,i)=max(buffhist);
end
for i=1:length(maxbeta)
    [out,SNRsys2(2,i),buffhist,smallfading,powersys2(2,i)]=systembufferM(x,EsN0,SigmX,SigmN,noise,tc,fading,maxbeta(i));
    maxbuffsys2(2,i)=max(buffhist);
end



figure();
subplot(1,2,1);hold on;
%plot(maxbeta,ones(1,length(maxbeta))*28.3419,'k--'); %OPTAfadingbeta: M=2,N=20000
%plot(maxbeta,ones(1,length(maxbeta))*16.8884,'k-.');%OPTAfadingbeta: M=8,N=20000
plot(maxbeta,10*log10(powersys1(1,:)));
plot(maxbeta,10*log10(powersys1(2,:)),'r');
plot(maxbeta,10*log10(powersys2(1,:)),'g');
plot(maxbeta,10*log10(powersys2(2,:)),'m');
xlabel('Outage level (dB)'),ylabel('Average Power (dB)')
legend('System1-M=2','System1-M=8','System2-R_i_n=8','System2-R_i_n=2','Location','NorthWest')
%legend('No-power-lim (M=4)','No-power-lim (M=16)','System1-M=2','System1-M=8','System2-R_i_n=8','System2-R_i_n=2')
hold off;

subplot(1,2,2),hold on;
plot(maxbeta,maxbuffsys1(1,:));
plot(maxbeta,maxbuffsys1(1,:),'r');
plot(maxbeta,maxbuffsys2(1,:),'g');
plot(maxbeta,maxbuffsys2(2,:),'m');
xlabel('Outage level (dB)'),ylabel('Maximum delay (samples)')
legend('System1-M=2','System1-M=8','System2-R_i_n=8','System2-R_i_n=2');
hold off;
% 
% 
% %Power of OPTAfadingbeta for EsN0=10 dB, M=4->13.9 dB, M=16->12.6 dB
