function sigmafading(fading)

tc=1:1:64;

sigmaalfa=zeros(1,length(tc));
for i=1:length(tc)

    l=floor(length(fading)/(tc(i)+1));
    vect=zeros(1,l);
    for j=1:l
        betaa=1/fading((j-1)*(tc(i)+1)+1);
        vect(j)=fading(j*(tc(i)+1))*betaa;
    end
    sigmaalfa(i)=var(vect);
end
a=sigmaalfa(end)/(tc(end))^2

figure()
plot(tc,sigmaalfa)
xlabel('M'),ylabel('\sigma^2'),hold on


m=1:64;
miau=5*m/20.*(1./(20./m+1)).^(m-1);
plot(miau,'r')
axis([1 64 0 1e-4])
hold off
for i=1:63
    if miau(i)<=sigmaalfa(i) && miau(i+1)>=sigmaalfa(i+1)
        i
    end
end